package com.loafle.bridge.discoveryport;

import com.fasterxml.jackson.annotation.JsonIgnore;
import com.loafle.bridge.discoveryport.type.DirectionType;

import javax.persistence.*;
import java.util.Date;

/**
 * Created by root on 16. 11. 15.
 */

@Entity
public class ServiceScanHistory {

    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    private long id;

    @Column(nullable = false, updatable = false)
    @Temporal(TemporalType.TIMESTAMP)
    private Date createDate;

    @ManyToOne
    @JoinColumn(nullable = false)
    @JsonIgnore
    private DiscoveryPort port;


    @Column(nullable = false)
    private String serviceName;

    @Column(nullable = false)
    @Enumerated(EnumType.STRING)
    private DirectionType direction;

    @Lob
    @Column(nullable = false)
    private byte[] packet;

    @Column
    private String description;

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public ServiceScanHistory() {}

    public ServiceScanHistory(DiscoveryPort port, String serviceName, DirectionType direction, byte[] packet, Date createAt) {
        this.port = port;
        this.serviceName = serviceName;
        this.direction = direction;
        this.packet = packet;
        this.createDate = createAt;
    }

    public long getId() {
        return id;
    }

    public void setId(long id) {
        this.id = id;
    }

    public DiscoveryPort getPort() {
        return port;
    }

    public void setPort(DiscoveryPort port) {
        this.port = port;
    }

    public String getServiceName() {
        return serviceName;
    }

    public void setServiceName(String serviceName) {
        this.serviceName = serviceName;
    }

    public DirectionType getDirection() {
        return direction;
    }

    public void setDirection(DirectionType direction) {
        this.direction = direction;
    }

    public Date getCreateDate() {
        return createDate;
    }

    public void setCreateDate(Date createDate) {
        this.createDate = createDate;
    }

    public byte[] getPacket() {
        return packet;
    }

    public void setPacket(byte[] packet) {
        this.packet = packet;
    }
}
