package com.loafle.bridge.discoveryzone;

import com.fasterxml.jackson.annotation.JsonIgnore;
import com.loafle.bridge.discoveryhistory.DiscoveryHistory;
import com.loafle.bridge.discoveryhost.DiscoveryHost;

import javax.persistence.*;
import java.util.List;

/**
 * Created by root on 16. 11. 15.
 */
@Entity
public class DiscoveryZone {


    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    private long id;

    @Column(nullable=false)
    private long ip;

    @Column(nullable=false)
    private long cidr;

    @JoinColumn
    @OneToOne
    @JsonIgnore
    private DiscoveryHistory discovery;

    @OneToMany(mappedBy = "zone", cascade = CascadeType.ALL)
    private List<HostScanHistory> histories;

    @OneToMany(mappedBy = "zone", cascade = CascadeType.ALL)
    private List<DiscoveryHost> discoveryHosts;

    public List<HostScanHistory> getHistories() {
        return histories;
    }

    public void setHistories(List<HostScanHistory> histories) {
        this.histories = histories;
    }

    public List<DiscoveryHost> getDiscoveryHosts() {
        return discoveryHosts;
    }

    public void setDiscoveryHosts(List<DiscoveryHost> discoveryHosts) {
        this.discoveryHosts = discoveryHosts;
    }

    public long getId() {
        return id;
    }

    public void setId(long id) {
        this.id = id;
    }

    public long getIp() {
        return ip;
    }

    public void setIp(long ip) {
        this.ip = ip;
    }

    public long getCidr() {
        return cidr;
    }

    public void setCidr(long cidr) {
        this.cidr = cidr;
    }

    public DiscoveryHistory getDiscovery() {
        return discovery;
    }

    public void setDiscovery(DiscoveryHistory discovery) {
        this.discovery = discovery;
    }


    public void mappingChildren(DiscoveryHistory history) {
        this.setDiscovery(history);
        List<HostScanHistory> hostScanHistories = this.getHistories();
        if (hostScanHistories != null) {
            for (int i =0 ; i < hostScanHistories.size() ; ++i) {
                hostScanHistories.get(i).setZone(this);
            }
        }

        List<DiscoveryHost> hosts = this.getDiscoveryHosts();
        if (hosts != null) {
            for (int i =0 ; i < hosts.size() ; ++i) {
                hosts.get(i).mappingChildren(this);
            }
        }
    }
}
